<?php

/**
 * inf_fac_cliente_consol actions.
 *
 * @package    cartera
 * @subpackage inf_nota_credito
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_fac_cliente_consolActions extends sfQuery {

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para listar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $tope_ventas = $request['tope_ventas'];
            /*if (isset($request['estado'])) {
                if ($request['estado'] == 'false') {
                    $estado = 0;
                } else {
                    $estado = 1;
                }
            } else {
                $estado = 1;
            }*/
            
            /*
             * Variables opcionales
             */
            //tercero
                       
            //PUNTO DE VENTA
            
            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
           } else {
                $wherePuntoVenta = ' ';
            }
            //tipo debito
            
//            
//               if (isset($request['id_con_credito'])) {
//                $whereConCredito = " AND tab0.id_con_credito = " . $request['id_con_credito'];
//            } else {
//                $whereConCredito = ' ';
//            }
//            
//            
//                       
//               if (isset($request['id_mae_ter'])) {
//                $whereTercero = " AND tab1.mae_ter = " . $request['id_mae_ter'];
//            } else {
//                $whereTercero = ' ';
//            }
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * Formato de fecha sin time
             */
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;

            CN_TABLE::executeSQL($sql);


            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            /*
              To_Char(Tab0.Fecha_Proceso, 'YYYY-MM-DD') Between '$fecha_ini' And '$fecha_fin'
              and Tab0.estado = $estado
              $whereTercero
             */
            $sql = <<<EOD

select count(*) as count from (

Select * From (

select tab0.id_mae_ter,tab0.nit,tab0.nombre,sum(NVL(tab0.valor_factura,0)) AS VALOR_FACTURA,sum(NVL(tab0.descuentos,0)) AS DESCUENTOS,sum(NVL(tab0.iva,0)) AS IVA,sum(NVL(tab0.total,0)) AS TOTAL

from(

select

            tab2.id_punto_venta,
tab1.id_mae_ter ID_MAE_TER,
tab1.estado AS ESTADO,
tab3.num_doc AS NIT,
tab1.fecha_facturacion AS FECHA,
case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
tab1.valor_bruto AS VALOR_FACTURA,
0 AS DESCUENTOS,
tab1.valor_iva AS IVA,
tab1.valor_total AS TOTAL

from ca_factura_pos tab1

left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter
where tab2.es_pos=1 and To_Char(tab1.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado=1


UNION

select

            tab5.id_punto_venta,
tab4.id_mae_ter ID_MAE_TER,
tab4.estado AS ESTADO,
tab6.num_doc AS NIT,
tab4.fecha_proceso AS FECHA,
case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
tab4.valor_bruto AS VALOR_FACTURA,
0 AS DESCUENTOS,
tab4.valor_iva AS IVA,
tab4.valor_total AS TOTAL



from ca_debito tab4
left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


) tab0
where tab0.id_mae_ter IS NOT NULL $wherePuntoVenta and tab0.total>= $tope_ventas
GROUP BY tab0.id_mae_ter,tab0.nit,tab0.nombre

)
)

EOD;

            



$total_record_count = CN_TABLE::executeSQL($sql);
$total_record_count = $total_record_count[0]["count"];


            
            
            
            //obtener el listado de recaudos
            $sql = <<<EOD

SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (


select tab0.id_mae_ter,tab0.nit,tab0.nombre,sum(NVL(tab0.valor_factura,0)) AS VALOR_FACTURA,sum(NVL(tab0.descuentos,0)) AS DESCUENTOS,sum(NVL(tab0.iva,0)) AS VALOR_IVA,sum(NVL(tab0.total,0)) AS TOTAL

            from(

            select

            tab2.id_punto_venta,
            tab1.id_mae_ter ID_MAE_TER,
            tab1.estado AS ESTADO,
            tab3.num_doc AS NIT,
            tab1.fecha_facturacion AS FECHA,
            case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
            tab1.valor_bruto AS VALOR_FACTURA,
            0 AS DESCUENTOS,
            tab1.valor_iva AS IVA,
            tab1.valor_total AS TOTAL

            from ca_factura_pos tab1

            left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
            left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter
            where tab2.es_pos=1 and To_Char(tab1.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado=1


            UNION

            select

            tab5.id_punto_venta,
            tab4.id_mae_ter ID_MAE_TER,
            tab4.estado AS ESTADO,
            tab6.num_doc AS NIT,
            tab4.fecha_proceso AS FECHA,
            case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
            tab4.valor_bruto AS VALOR_FACTURA,
            0 AS DESCUENTOS,
            tab4.valor_iva AS IVA,
            tab4.valor_total AS TOTAL



            from ca_debito tab4
            left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
            left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
            left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

            where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


            ) tab0
            where tab0.id_mae_ter IS NOT NULL $wherePuntoVenta and tab0.total>= $tope_ventas
            GROUP BY tab0.id_mae_ter,tab0.nit,tab0.nombre


) row_ WHERE ROWNUM <=  $rowEnd   

) where rownum_ >  $rowStart

EOD;
        
       
            
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar el informe nota debito
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        //manejo de errores
        try {

                /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $tope_ventas = $request['tope_ventas'];
            
            
            /*
             * Variables opcionales
             */
            //tercero
                       
            //PUNTO DE VENTA
            
            if (isset($request['id_punto_venta'])) {
                $wherePuntoVenta = " AND tab0.id_punto_venta = " . $request['id_punto_venta'];
           } else {
                $wherePuntoVenta = ' ';
            }
            
            
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
            SELECT count(*) as nit, 'TOTALES NOTAS CREDITO' as nombre,
            SUM(NVL(valor_factura,0)) as valor_factura, 
            SUM(NVL(descuentos,0)) as descuentos, 
            SUM(NVL(iva,0)) as valor_iva, 
            SUM(NVL(total,0)) as total

            FROM (

            select tab0.id_mae_ter,tab0.nit,tab0.nombre,sum(NVL(tab0.valor_factura,0)) AS VALOR_FACTURA,sum(NVL(tab0.descuentos,0)) AS DESCUENTOS,sum(NVL(tab0.iva,0)) AS IVA,sum(NVL(tab0.total,0)) AS TOTAL

            from(

            select
            tab2.id_punto_venta,
            tab1.id_mae_ter ID_MAE_TER,
            tab1.estado AS ESTADO,
            tab3.num_doc AS NIT,
            tab1.fecha_facturacion AS FECHA,
            case when tab3.razon_soc IS NOT NULL then tab3.razon_soc else tab3.pnombre||' '||tab3.snombre||' '||tab3.papellido||' '||tab3.sapellido end AS NOMBRE,
            tab1.valor_bruto AS VALOR_FACTURA,
            0 AS DESCUENTOS,
            tab1.valor_iva AS IVA,
            tab1.valor_total AS TOTAL

            from ca_factura_pos tab1

            left join ca_punto_venta tab2 ON tab2.id_punto_venta = tab1.id_punto_venta
            left join interceros tab3 ON tab3.id_mae_ter = tab1.id_mae_ter
            where tab2.es_pos=1 and To_Char(tab1.fecha_facturacion, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab1.estado=1


            UNION

            select
            tab5.id_punto_venta,
            tab4.id_mae_ter ID_MAE_TER,
            tab4.estado AS ESTADO,
            tab6.num_doc AS NIT,
            tab4.fecha_proceso AS FECHA,
            case when tab6.razon_soc IS NOT NULL then tab6.razon_soc else tab6.pnombre||' '||tab6.snombre||' '||tab6.papellido||' '||tab6.sapellido end AS NOMBRE,
            tab4.valor_bruto AS VALOR_FACTURA,
            0 AS DESCUENTOS,
            tab4.valor_iva AS IVA,
            tab4.valor_total AS TOTAL



            from ca_debito tab4
            left join ca_punto_venta tab5 ON tab5.id_punto_venta = tab4.id_punto_venta
            left join interceros tab6 ON tab6.id_mae_ter = tab4.id_mae_ter
            left join ca_vencimientos tab7 ON tab7.id_debito = tab4.id_debito

            where tab4.id_tipo_debito=1 and To_Char(tab4.fecha_proceso, 'YYYY-MM-DD') between '$fecha_ini' And '$fecha_fin' and tab4.estado=1


            ) tab0
            where tab0.id_mae_ter IS NOT NULL $wherePuntoVenta and tab0.total>= $tope_ventas
            GROUP BY tab0.id_mae_ter,tab0.nit,tab0.nombre

            )

EOD;
            
            
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
